Index: issm/branches/trunk-jpl-damage/src/c/classes/matrix/ElementVector.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/classes/matrix/ElementVector.cpp	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/classes/matrix/ElementVector.cpp	(revision 12878)
@@ -0,0 +1,276 @@
+/*!\file ElementVector.cpp
+ * \brief: implementation of the ElementVector object, used to plug values from element into global load
+ */
+
+/*Headers:*/
+/*{{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include <stdio.h>
+#include <string.h>
+#include "../classes.h"
+#include "../../shared/shared.h"
+#include "../../Container/Container.h"
+#include "../../include/include.h"
+/*}}}*/
+
+/*ElementVector constructors and destructor*/
+/*FUNCTION ElementVector::ElementVector(){{{*/
+ElementVector::ElementVector(){
+
+	this->nrows=0;
+	this->values=NULL;
+	this->fsize=0;
+	this->flocaldoflist=NULL;
+	this->fglobaldoflist=NULL;
+
+}
+/*}}}*/
+/*FUNCTION ElementVector::ElementVector(ElementVector* pe1, ElementVector* pe2){{{*/
+ElementVector::ElementVector(ElementVector* pe1, ElementVector* pe2){
+
+	/*intermediaries*/
+	int i,j,counter;
+	int gsize,fsize,ssize;
+	int* P=NULL;
+	bool found;
+
+	/*If one of the two matrix is NULL, we copy the other one*/
+	if(!pe1 && !pe2){
+		_error2_("Two input element matrices are NULL");
+	}
+	else if(!pe1){
+		this->Init(pe2);
+		return;
+	}
+	else if(!pe2){
+		this->Init(pe1);
+		return;
+	}
+
+	/*Initialize itransformation matrix pe[P[i]] = pe2[i]*/
+	P=xNew<int>(pe2->nrows);
+
+	/*1: Get the new numbering of pe2 and get size of the new matrix*/
+	gsize=pe1->nrows;
+	for(i=0;i<pe2->nrows;i++){
+		found=false;
+		for(j=0;j<pe1->nrows;j++){
+			if(pe2->gglobaldoflist[i]==pe1->gglobaldoflist[j]){
+				found=true; P[i]=j; break;
+			}
+		}
+		if(!found){
+			P[i]=gsize; gsize++;
+		}
+	}
+
+	/*2: Initialize static fields*/
+	this->nrows=gsize;
+
+	/*Gset and values*/
+	this->gglobaldoflist=xNew<int>(this->nrows);
+	this->values=xNewZeroInit<IssmDouble>(this->nrows);
+	for(i=0;i<pe1->nrows;i++){
+		this->values[i] += pe1->values[i];
+		this->gglobaldoflist[i]=pe1->gglobaldoflist[i];
+	}
+	for(i=0;i<pe2->nrows;i++){
+		this->values[P[i]] += pe2->values[i];
+		this->gglobaldoflist[P[i]]=pe2->gglobaldoflist[i];
+	}
+
+	/*Fset*/
+	fsize=pe1->fsize;
+	for(i=0;i<pe2->fsize;i++){
+		if(P[pe2->flocaldoflist[i]] >= pe1->nrows) fsize++;
+	}
+	this->fsize=fsize;
+	if(fsize){
+		this->flocaldoflist =xNew<int>(fsize);
+		this->fglobaldoflist=xNew<int>(fsize);
+		for(i=0;i<pe1->fsize;i++){
+			this->flocaldoflist[i] =pe1->flocaldoflist[i];
+			this->fglobaldoflist[i]=pe1->fglobaldoflist[i];
+		}
+		counter=pe1->fsize;
+		for(i=0;i<pe2->fsize;i++){
+			if(P[pe2->flocaldoflist[i]] >= pe1->nrows){
+				this->flocaldoflist[counter] =P[pe2->flocaldoflist[i]];
+				this->fglobaldoflist[counter]=pe2->fglobaldoflist[i];
+				counter++;
+			}
+		}
+	}
+	else{
+		this->flocaldoflist=NULL;
+		this->fglobaldoflist=NULL;
+	}
+
+	/*clean-up*/
+	xDelete<int>(P);
+}
+/*}}}*/
+/*FUNCTION ElementVector::ElementVector(ElementVector* pe1, ElementVector* pe2,ElementVector* pe3){{{*/
+ElementVector::ElementVector(ElementVector* pe1, ElementVector* pe2,ElementVector* pe3){
+
+	/*Concatenate all matrices*/
+	ElementVector* pe12 =new ElementVector(pe1,pe2);
+	ElementVector* pe123=new ElementVector(pe12,pe3);
+
+	/*Initialize current object with this matrix*/
+	this->Init(pe123);
+
+	/*clean-up*/
+	delete pe12;
+	delete pe123;
+}
+/*}}}*/
+/*FUNCTION ElementVector::ElementVector(Node** nodes,int numnodes,Parameters* parameters,int approximation){{{*/
+ElementVector::ElementVector(Node** nodes,int numnodes,Parameters* parameters,int approximation){
+
+	/*get Vector size and properties*/
+	this->nrows=GetNumberOfDofs(nodes,numnodes,GsetEnum,approximation);
+
+	/*fill values with 0: */
+	this->values=xNewZeroInit<IssmDouble>(this->nrows);
+	
+	/*g list*/
+	this->gglobaldoflist=GetGlobalDofList(nodes,numnodes,GsetEnum,approximation);
+
+	/*Get fsize*/
+	this->fsize=GetNumberOfDofs(nodes,numnodes,FsetEnum,approximation);
+	this->flocaldoflist =GetLocalDofList( nodes,numnodes,FsetEnum,approximation);
+	this->fglobaldoflist=GetGlobalDofList(nodes,numnodes,FsetEnum,approximation);
+}
+/*}}}*/
+/*FUNCTION ElementVector::~ElementVector(){{{*/
+ElementVector::~ElementVector(){
+	
+	xDelete<IssmDouble>(this->values);
+	xDelete<int>(this->gglobaldoflist);
+	xDelete<int>(this->flocaldoflist);
+	xDelete<int>(this->fglobaldoflist);
+}
+/*}}}*/
+
+/*ElementVector specific routines: */
+/*FUNCTION ElementVector::AddToGlobal(Vector* pf){{{*/
+void ElementVector::AddToGlobal(Vector* pf){
+
+	int i;
+	IssmDouble* localvalues=NULL;
+
+	/*In debugging mode, check consistency (no NaN, and values not too big)*/
+	this->CheckConsistency();
+
+	if(this->fsize){
+		/*first, retrieve values that are in the f-set from the g-set values vector: */
+		localvalues=xNew<IssmDouble>(this->fsize);
+		for(i=0;i<this->fsize;i++){
+			localvalues[i]=this->values[this->flocaldoflist[i]];
+		}
+		/*add local values into global  vector, using the fglobaldoflist: */
+		pf->SetValues(this->fsize,this->fglobaldoflist,localvalues,ADD_VAL);
+
+		/*Free ressources:*/
+		xDelete<IssmDouble>(localvalues);
+	}
+	
+}
+/*}}}*/
+/*FUNCTION ElementVector::InsertIntoGlobal(Vector* pf){{{*/
+void ElementVector::InsertIntoGlobal(Vector* pf){
+
+	int i;
+	IssmDouble* localvalues=NULL;
+
+	if(this->fsize){
+		/*first, retrieve values that are in the f-set from the g-set values vector: */
+		localvalues=xNew<IssmDouble>(this->fsize);
+		for(i=0;i<this->fsize;i++){
+			localvalues[i]=this->values[this->flocaldoflist[i]];
+		}
+		/*add local values into global  vector, using the fglobaldoflist: */
+		pf->SetValues(this->fsize,this->fglobaldoflist,localvalues,INS_VAL);
+
+		/*Free ressources:*/
+		xDelete<IssmDouble>(localvalues);
+	}
+
+}
+/*}}}*/
+/*FUNCTION ElementVector::CheckConsistency{{{*/
+void ElementVector::CheckConsistency(void){
+	/*Check element matrix values, only in debugging mode*/
+#ifdef _ISSM_DEBUG_ 
+	for (int i=0;i<this->nrows;i++){
+		if (xIsNan<IssmDouble>(this->values[i])) _error2_("NaN found in Element Vector");
+		if (fabs( this->values[i])>1.e+50) _error2_("Element Vector values exceeds 1.e+50");
+	}
+#endif
+}
+/*}}}*/
+/*FUNCTION ElementVector::Echo{{{*/
+void ElementVector::Echo(void){
+
+	int i,j;
+	_printLine_("Element Vector echo:");
+	_printLine_("   nrows: " << nrows);
+	_printLine_("   values:");
+	for(i=0;i<nrows;i++){
+		_printLine_(setw(4) << right << i << ": " << setw(10) << values[i]);
+	}
+
+	_printString_("   gglobaldoflist (" << gglobaldoflist << "): ");
+	if(gglobaldoflist) for(i=0;i<nrows;i++) _printString_(" " << gglobaldoflist[i] );
+	_printLine_(" ");
+
+	_printLine_("   fsize: " << fsize);
+	_printString_("   flocaldoflist  (" << flocaldoflist << "): ");
+	if(flocaldoflist) for(i=0;i<fsize;i++) _printString_(" " << flocaldoflist[i] );
+	_printLine_(" ");
+	_printString_("   fglobaldoflist (" << fglobaldoflist << "): ");
+	if(fglobaldoflist) for(i=0;i<fsize;i++) _printString_(" " << fglobaldoflist[i] );
+	_printLine_(" ");
+}
+/*}}}*/
+/*FUNCTION ElementVector::Init{{{*/
+void ElementVector::Init(ElementVector* pe){
+
+	_assert_(pe);
+
+	this->nrows =pe->nrows;
+
+	this->values=xNew<IssmDouble>(this->nrows);
+	xMemCpy<IssmDouble>(this->values,pe->values,this->nrows);
+
+	this->gglobaldoflist=xNew<int>(this->nrows);
+	xMemCpy<int>(this->gglobaldoflist,pe->gglobaldoflist,this->nrows);
+
+	this->fsize=pe->fsize;
+	if(this->fsize){
+		this->flocaldoflist=xNew<int>(this->fsize);
+		xMemCpy<int>(this->flocaldoflist,pe->flocaldoflist,this->fsize);
+		this->fglobaldoflist=xNew<int>(this->fsize);
+		xMemCpy<int>(this->fglobaldoflist,pe->fglobaldoflist,this->fsize);
+	}
+	else{
+		this->flocaldoflist=NULL;
+		this->fglobaldoflist=NULL;
+	}
+}
+/*}}}*/
+/*FUNCTION ElementVector::SetValue{{{*/
+void ElementVector::SetValue(IssmDouble scalar){
+
+	int i;
+
+	for(i=0;i<this->nrows;i++)this->values[i]=scalar;
+
+}
+/*}}}*/
Index: issm/branches/trunk-jpl-damage/src/c/classes/matrix/Matrix.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/classes/matrix/Matrix.cpp	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/classes/matrix/Matrix.cpp	(revision 12878)
@@ -0,0 +1,323 @@
+/*!\file Matrix.cpp
+ * \brief: implementation of the Matrix object
+ */
+
+/*Headers:*/
+/*{{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include <stdio.h>
+#include <string.h>
+#include "../classes.h"
+#include "../../shared/shared.h"
+#include "../../Container/Container.h"
+#include "../../include/include.h"
+#include "../../toolkits/toolkits.h"
+#include "./Matrix.h"
+	
+/*}}}*/
+
+/*Matrix constructors and destructor*/
+/*FUNCTION Matrix::Matrix(){{{*/
+Matrix::Matrix(){
+
+	pmatrix=NULL;
+	smatrix=NULL;
+
+	type=PetscMatType; //default
+	#ifndef _HAVE_PETSC_
+	type=SeqMatType;
+	#endif
+	
+}
+/*}}}*/
+/*FUNCTION Matrix::Matrix(int M,int N,int type){{{*/
+Matrix::Matrix(int M,int N,int in_type){
+
+	pmatrix=NULL;
+	smatrix=NULL;
+	type=in_type;
+
+	if(type==PetscMatType){
+		#ifdef _HAVE_PETSC_
+		this->pmatrix=new PetscMat(M,N);
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqMatType){
+		this->smatrix=new SeqMat(M,N);
+	}
+	else _error2_("Matrix type: " << type << " not supported yet!");
+
+}
+/*}}}*/
+/*FUNCTION Matrix::Matrix(int M,int N,IssmDouble sparsity,int type){{{*/
+Matrix::Matrix(int M,int N,IssmDouble sparsity,int in_type){
+
+	pmatrix=NULL;
+	smatrix=NULL;
+	type=in_type;
+
+	if(type==PetscMatType){
+		#ifdef _HAVE_PETSC_
+		this->pmatrix=new PetscMat(M,N,sparsity);
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqMatType){
+		this->smatrix=new SeqMat(M,N,sparsity);
+	}
+	else _error2_("Matrix type: " << type << " not supported yet!");
+}
+/*}}}*/
+/*FUNCTION Matrix::Matrix(IssmDouble* serial_mat, int M,int N,IssmDouble sparsity,int type){{{*/
+Matrix::Matrix(IssmDouble* serial_mat, int M,int N,IssmDouble sparsity,int in_type){
+
+	pmatrix=NULL;
+	smatrix=NULL;
+	type=in_type;
+
+	if(type==PetscMatType){
+		#ifdef _HAVE_PETSC_
+		this->pmatrix=new PetscMat(serial_mat,M,N,sparsity);
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqMatType){
+		this->smatrix=new SeqMat(serial_mat,M,N,sparsity);
+	}
+	else _error2_("Matrix type: " << type << " not supported yet!");
+	
+}
+/*}}}*/
+/*FUNCTION Matrix::Matrix(int M,int N,int connectivity,int numberofdofspernode,int type){{{*/
+Matrix::Matrix(int M,int N,int connectivity,int numberofdofspernode,int in_type){
+
+	pmatrix=NULL;
+	smatrix=NULL;
+	type=in_type;
+
+	if(type==PetscMatType){
+		#ifdef _HAVE_PETSC_
+		this->pmatrix=new PetscMat(M,N,connectivity,numberofdofspernode);
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqMatType){
+		this->smatrix=new SeqMat(M,N,connectivity,numberofdofspernode);
+	}
+	else _error2_("Matrix type: " << type << " not supported yet!");
+	
+}
+/*}}}*/
+/*FUNCTION Matrix::~Matrix(){{{*/
+Matrix::~Matrix(){
+
+	if(type==PetscMatType){
+		#ifdef _HAVE_PETSC_
+		delete this->pmatrix;
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqMatType){
+		delete this->smatrix;
+	}
+	else _error2_("Matrix type: " << type << " not supported yet!");
+
+}
+/*}}}*/
+
+/*Matrix specific routines: */
+/*FUNCTION Matrix::Echo{{{*/
+void Matrix::Echo(void){
+
+	if(type==PetscMatType){
+		#ifdef _HAVE_PETSC_
+		this->pmatrix->Echo();
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqMatType){
+		this->smatrix->Echo();
+	}
+	else _error2_("Matrix type: " << type << " not supported yet!");
+
+}
+/*}}}*/
+/*FUNCTION Matrix::Assemble{{{*/
+void Matrix::Assemble(void){
+
+	if(type==PetscMatType){
+		#ifdef _HAVE_PETSC_
+		this->pmatrix->Assemble();
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqMatType){
+		this->smatrix->Assemble();
+	}
+	else{
+		_error2_("Matrix type: " << type << " not supported yet!");
+	}
+}
+/*}}}*/
+/*FUNCTION Matrix::Norm{{{*/
+IssmDouble Matrix::Norm(NormMode norm_type){
+	
+	IssmDouble norm=0;
+
+	if(type==PetscMatType){
+		#ifdef _HAVE_PETSC_
+		norm=this->pmatrix->Norm(norm_type);
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqMatType){
+		norm=this->smatrix->Norm(norm_type);
+	}
+	else _error2_("Matrix type: " << type << " not supported yet!");
+
+	return norm;
+}
+/*}}}*/
+/*FUNCTION Matrix::GetSize{{{*/
+void Matrix::GetSize(int* pM,int* pN){
+
+	if(type==PetscMatType){
+		#ifdef _HAVE_PETSC_
+		this->pmatrix->GetSize(pM,pN);
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqMatType){
+		this->smatrix->GetSize(pM,pN);
+	}
+	else _error2_("Matrix type: " << type << " not supported yet!");
+	
+}
+/*}}}*/
+/*FUNCTION Matrix::GetLocalSize{{{*/
+void Matrix::GetLocalSize(int* pM,int* pN){
+	
+	if(type==PetscMatType){
+		#ifdef _HAVE_PETSC_
+		this->pmatrix->GetLocalSize(pM,pN);
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqMatType){
+		this->smatrix->GetLocalSize(pM,pN);
+	}
+	else _error2_("Matrix type: " << type << " not supported yet!");
+
+}
+/*}}}*/
+/*FUNCTION Matrix::MatMult{{{*/
+void Matrix::MatMult(Vector* X,Vector* AX){
+
+	if(type==PetscMatType){
+		#ifdef _HAVE_PETSC_
+		this->pmatrix->MatMult(X->pvector,AX->pvector);
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqMatType){
+		this->smatrix->MatMult(X->svector,AX->svector);
+	}
+	else _error2_("Matrix type: " << type << " not supported yet!");
+
+}
+/*}}}*/
+/*FUNCTION Matrix::Duplicate{{{*/
+Matrix* Matrix::Duplicate(void){
+
+	Matrix* output=NULL;
+
+	output=new Matrix();
+
+	if(type==PetscMatType){
+		#ifdef _HAVE_PETSC_
+		output->pmatrix=this->pmatrix->Duplicate();
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqMatType){
+		output->smatrix=this->smatrix->Duplicate();
+	}
+	else _error2_("Matrix type: " << type << " not supported yet!");
+	
+	return output;
+}
+/*}}}*/
+/*FUNCTION Matrix::ToSerial{{{*/
+IssmDouble* Matrix::ToSerial(void){
+
+	IssmDouble* output=NULL;
+	
+	if(type==PetscMatType){
+		#ifdef _HAVE_PETSC_
+		output=this->pmatrix->ToSerial();
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqMatType){
+		output=this->smatrix->ToSerial();
+	}
+	else _error2_("Matrix type: " << type << " not supported yet!");
+
+
+	return output;
+}
+/*}}}*/
+/*FUNCTION Matrix::SetValues{{{*/
+void Matrix::SetValues(int m,int* idxm,int n,int* idxn,IssmDouble* values,InsMode mode){
+		
+	if(type==PetscMatType){
+		#ifdef _HAVE_PETSC_
+		this->pmatrix->SetValues(m,idxm,n,idxn,values,mode);
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqMatType){
+		this->smatrix->SetValues(m,idxm,n,idxn,values,mode);
+	}
+	else _error2_("Matrix type: " << type << " not supported yet!");
+}
+/*}}}*/
+/*FUNCTION Matrix::Convert{{{*/
+void Matrix::Convert(MatrixType newtype){
+
+	if(type==PetscMatType){
+		#ifdef _HAVE_PETSC_
+		this->pmatrix->Convert(newtype);
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqMatType){
+		this->smatrix->Convert(newtype);
+	}
+	else{
+		_error2_("Matrix type: " << type << " not supported yet!");
+	}
+
+}
+/*}}}*/
Index: issm/branches/trunk-jpl-damage/src/c/classes/matrix/Matrix.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/classes/matrix/Matrix.h	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/classes/matrix/Matrix.h	(revision 12878)
@@ -0,0 +1,54 @@
+/*!\file:  Matrix.h
+ * \brief wrapper to matrix objects. The goal is to control which API (PETSc,Scalpack, Plapack?) 
+ * implements our underlying matrix format.
+ */ 
+
+#ifndef _MATRIX_H_
+#define _MATRIX_H_
+
+/*Headers:*/
+/*{{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+#include "../../toolkits/toolkits.h"
+#include "../../EnumDefinitions/EnumDefinitions.h"
+/*}}}*/
+class Vector;
+enum matrixtype{PetscMatType, SeqMatType};
+
+class Matrix{
+
+	public:
+
+		#ifdef _HAVE_PETSC_
+		PetscMat *pmatrix;
+		#endif
+		SeqMat   *smatrix;
+		int       type;
+
+		/*Matrix constructors, destructors {{{*/
+		Matrix();
+		Matrix(int M,int N,int type=PetscMatType);
+		Matrix(int M,int N,IssmDouble sparsity,int type=PetscMatType);
+		Matrix(IssmDouble* serial_mat,int M,int N,IssmDouble sparsity,int type=PetscMatType);
+		Matrix(int M,int N,int connectivity,int numberofdofspernode,int type=PetscMatType);
+		~Matrix();
+		/*}}}*/
+		/*Matrix specific routines {{{*/
+		void        Echo(void);
+		void        Assemble(void);
+		IssmDouble  Norm(NormMode norm_type);
+		void        GetSize(int *pM,int*pN);
+		void        GetLocalSize(int *pM,int*pN);
+		void        MatMult(Vector *X,Vector*AX);
+		Matrix     *Duplicate(void);
+		IssmDouble *ToSerial(void);
+		void        SetValues(int m,int *idxm,int n,int*idxn,IssmDouble*values,InsMode mode);
+		void        Convert(MatrixType newtype);
+		/*}}}*/
+};
+
+#endif //#ifndef _MATRIX_H_
Index: issm/branches/trunk-jpl-damage/src/c/classes/matrix/Vector.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/classes/matrix/Vector.cpp	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/classes/matrix/Vector.cpp	(revision 12878)
@@ -0,0 +1,429 @@
+/*!\file Vector.cpp
+ * \brief: implementation of the Vector object
+ */
+
+/*Headers:*/
+/*{{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+
+#include <stdio.h>
+#include <string.h>
+#include "../classes.h"
+#include "../../shared/shared.h"
+#include "../../Container/Container.h"
+#include "../../include/include.h"
+#include "../../toolkits/toolkits.h"
+#include "./Vector.h"
+/*}}}*/
+
+/*Vector constructors and destructor*/
+/*FUNCTION Vector::Vector(){{{*/
+Vector::Vector(){
+
+	this->pvector=NULL;
+	this->svector=NULL;
+	
+	type=PetscVecType; //default
+	#ifndef _HAVE_PETSC_
+	type=SeqVecType;
+	#endif
+
+}
+/*}}}*/
+/*FUNCTION Vector::Vector(int M,bool fromlocalsize,int type){{{*/
+Vector::Vector(int M,bool fromlocalsize,int in_type){
+	
+	pvector=NULL;
+	svector=NULL;
+	type=in_type;
+
+
+	if(type==PetscVecType){
+		#ifdef _HAVE_PETSC_
+		this->pvector=new PetscVec(M,fromlocalsize);
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqVecType){
+		this->svector=new SeqVec(M,fromlocalsize);
+	}
+	else _error2_("Vector type: " << type << " not supported yet!");
+
+}
+/*}}}*/
+/*FUNCTION Vector::Vector(IssmDouble* serial_vec,int M,int type){{{*/
+Vector::Vector(IssmDouble* serial_vec,int M,int in_type){
+
+	pvector=NULL;
+	svector=NULL;
+	type=in_type;
+
+	if(type==PetscVecType){
+		#ifdef _HAVE_PETSC_
+		this->pvector=new PetscVec(serial_vec,M);
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqVecType){
+		this->svector=new SeqVec(serial_vec,M);
+	}
+	else _error2_("Vector type: " << type << " not supported yet!");
+
+}
+/*}}}*/
+/*FUNCTION Vector::~Vector(){{{*/
+Vector::~Vector(){
+
+	if(type==PetscVecType){
+		#ifdef _HAVE_PETSC_
+		delete this->pvector;
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqVecType){
+		delete this->svector;
+	}
+	else _error2_("Vector type: " << type << " not supported yet!");
+}
+/*}}}*/
+
+/*Vector specific routines: */
+/*FUNCTION Vector::Echo{{{*/
+void Vector::Echo(void){
+
+	if(type==PetscVecType){
+		#ifdef _HAVE_PETSC_
+		this->pvector->Echo();
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqVecType){
+		this->svector->Echo();
+	}
+	else _error2_("Vector type: " << type << " not supported yet!");
+
+}
+/*}}}*/
+/*FUNCTION Vector::Assemble{{{*/
+void Vector::Assemble(void){
+
+	if(type==PetscVecType){
+		#ifdef _HAVE_PETSC_
+		this->pvector->Assemble();
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqVecType){
+		this->svector->Assemble();
+	}
+	else _error2_("Vector type: " << type << " not supported yet!");
+
+}
+/*}}}*/
+/*FUNCTION Vector::SetValues{{{*/
+void Vector::SetValues(int ssize, int* list, IssmDouble* values, InsMode mode){
+		
+
+	if(type==PetscVecType){
+		#ifdef _HAVE_PETSC_
+		this->pvector->SetValues(ssize,list,values,mode);
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqVecType){
+		this->svector->SetValues(ssize,list,values,mode);
+	}
+	else _error2_("Vector type: " << type << " not supported yet!");
+
+		
+
+}
+/*}}}*/
+/*FUNCTION Vector::SetValue{{{*/
+void Vector::SetValue(int dof, IssmDouble value, InsMode mode){
+	
+	if(type==PetscVecType){
+		#ifdef _HAVE_PETSC_
+		this->pvector->SetValue(dof,value,mode);
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqVecType){
+		this->svector->SetValue(dof,value,mode);
+	}
+	else _error2_("Vector type: " << type << " not supported yet!");
+
+}
+/*}}}*/
+/*FUNCTION Vector::GetValue{{{*/
+void Vector::GetValue(IssmDouble* pvalue,int dof){
+		
+
+	if(type==PetscVecType){
+		#ifdef _HAVE_PETSC_
+		this->pvector->GetValue(pvalue,dof);
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqVecType){
+		this->svector->GetValue(pvalue,dof);
+	}
+	else _error2_("Vector type: " << type << " not supported yet!");
+
+}
+/*}}}*/
+/*FUNCTION Vector::GetSize{{{*/
+void Vector::GetSize(int* pM){
+	
+	if(type==PetscVecType){
+		#ifdef _HAVE_PETSC_
+		this->pvector->GetSize(pM);
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqVecType){
+		this->svector->GetSize(pM);
+	}
+	else _error2_("Vector type: " << type << " not supported yet!");
+
+}
+/*}}}*/
+/*FUNCTION Vector::IsEmpty{{{*/
+bool Vector::IsEmpty(void){
+
+	int M;
+
+	this->GetSize(&M);
+
+	if(M==0) 
+	 return true;
+	else
+	 return false;
+}
+/*}}}*/
+/*FUNCTION Vector::GetLocalSize{{{*/
+void Vector::GetLocalSize(int* pM){
+		
+
+	if(type==PetscVecType){
+		#ifdef _HAVE_PETSC_
+		this->pvector->GetLocalSize(pM);
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqVecType){
+		this->svector->GetLocalSize(pM);
+	}
+	else _error2_("Vector type: " << type << " not supported yet!");
+
+}
+/*}}}*/
+/*FUNCTION Vector::Duplicate{{{*/
+Vector* Vector::Duplicate(void){
+	
+	Vector* output=NULL;
+
+
+	if(type==PetscVecType){
+		#ifdef _HAVE_PETSC_
+		output=new Vector();
+		output->pvector=this->pvector->Duplicate();
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqVecType){
+		output=new Vector();
+		output->svector=this->svector->Duplicate();
+	}
+	else _error2_("Vector type: " << type << " not supported yet!");
+
+	return output;
+
+}
+/*}}}*/
+/*FUNCTION Vector::Set{{{*/
+void Vector::Set(IssmDouble value){
+	
+	
+	if(type==PetscVecType){
+		#ifdef _HAVE_PETSC_
+		this->pvector->Set(value);
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqVecType){
+		this->svector->Set(value);
+	}
+	else _error2_("Vector type: " << type << " not supported yet!");
+
+}
+/*}}}*/
+/*FUNCTION Vector::AXPY{{{*/
+void Vector::AXPY(Vector* X, IssmDouble a){
+	
+
+	if(type==PetscVecType){
+		#ifdef _HAVE_PETSC_
+		this->pvector->AXPY(X->pvector,a);
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqVecType){
+		this->svector->AXPY(X->svector,a);
+	}
+	else _error2_("Vector type: " << type << " not supported yet!");
+
+}
+/*}}}*/
+/*FUNCTION Vector::AYPX{{{*/
+void Vector::AYPX(Vector* X, IssmDouble a){
+	
+
+	if(type==PetscVecType){
+		#ifdef _HAVE_PETSC_
+		this->pvector->AYPX(X->pvector,a);
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqVecType){
+		this->svector->AYPX(X->svector,a);
+	}
+	else _error2_("Vector type: " << type << " not supported yet!");
+
+
+}
+/*}}}*/
+/*FUNCTION Vector::ToMPISerial{{{*/
+IssmDouble* Vector::ToMPISerial(void){
+
+	IssmDouble* vec_serial=NULL;
+
+	if(type==PetscVecType){
+		#ifdef _HAVE_PETSC_
+		vec_serial=this->pvector->ToMPISerial();
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqVecType){
+		vec_serial=this->svector->ToMPISerial();
+	}
+	else _error2_("Vector type: " << type << " not supported yet!");
+
+	return vec_serial;
+
+}
+/*}}}*/
+/*FUNCTION Vector::Copy{{{*/
+void Vector::Copy(Vector* to){
+
+	
+	if(type==PetscVecType){
+		#ifdef _HAVE_PETSC_
+		this->pvector->Copy(to->pvector);
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqVecType){
+		this->svector->Copy(to->svector);
+	}
+	else _error2_("Vector type: " << type << " not supported yet!");
+
+
+}
+/*}}}*/
+/*FUNCTION Vector::Norm{{{*/
+IssmDouble Vector::Norm(NormMode norm_type){
+	
+	IssmDouble norm=0;
+
+	if(type==PetscVecType){
+		#ifdef _HAVE_PETSC_
+		norm=this->pvector->Norm(norm_type);
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqVecType){
+		norm=this->svector->Norm(norm_type);
+	}
+	else _error2_("Vector type: " << type << " not supported yet!");
+
+	return norm;
+}
+/*}}}*/
+/*FUNCTION Vector::Scale{{{*/
+void Vector::Scale(IssmDouble scale_factor){
+	
+
+	if(type==PetscVecType){
+		#ifdef _HAVE_PETSC_
+		this->pvector->Scale(scale_factor);
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqVecType){
+		this->svector->Scale(scale_factor);
+	}
+	else _error2_("Vector type: " << type << " not supported yet!");
+
+}
+/*}}}*/
+/*FUNCTION Vector::Dot{{{*/
+IssmDouble Vector::Dot(Vector* vector){
+
+	IssmDouble dot;
+	
+	if(type==PetscVecType){
+		#ifdef _HAVE_PETSC_
+		dot=this->pvector->Dot(vector->pvector);
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqVecType){
+		dot=this->svector->Dot(vector->svector);
+	}
+	else _error2_("Vector type: " << type << " not supported yet!");
+
+	return dot;
+}
+/*}}}*/
+/*FUNCTION Vector::PointwiseDivide{{{*/
+void Vector::PointwiseDivide(Vector* x,Vector* y){
+
+
+	if(type==PetscVecType){
+		#ifdef _HAVE_PETSC_
+		this->pvector->PointwiseDivide(x->pvector,y->pvector);
+		#else
+		_error2_("Petsc matrix format not usable, as Petsc has not been compiled!");
+		#endif
+	}
+	else if(type==SeqVecType){
+		this->svector->PointwiseDivide(x->svector,y->svector);
+	}
+	else _error2_("Vector type: " << type << " not supported yet!");
+
+}
+/*}}}*/
Index: issm/branches/trunk-jpl-damage/src/c/classes/matrix/Vector.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/classes/matrix/Vector.h	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/classes/matrix/Vector.h	(revision 12878)
@@ -0,0 +1,63 @@
+/*!\file:  Vector.h
+ * \brief wrapper to vector objects. The goal is to control which API (PETSc,Scalpack, Plapack?) 
+ * implements our underlying vector format.
+ */ 
+
+#ifndef _VECTOR_H_
+#define _VECTOR_H_
+
+/*Headers:*/
+/*{{{*/
+#ifdef HAVE_CONFIG_H
+	#include <config.h>
+#else
+#error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
+#endif
+#include "../../toolkits/toolkits.h"
+#include "../../EnumDefinitions/EnumDefinitions.h"
+
+/*}}}*/
+
+enum vectortype { PetscVecType, SeqVecType };
+
+class Vector{
+
+	public:
+
+		#ifdef _HAVE_PETSC_
+		PetscVec* pvector;
+		#endif
+		SeqVec* svector; 
+		int     type;
+	
+
+		/*Vector constructors, destructors {{{*/
+		Vector();
+		Vector(int M,bool fromlocalsize=false,int type=PetscVecType);
+		Vector(IssmDouble* serial_vec,int pM,int type=PetscVecType);
+		~Vector();
+		/*}}}*/
+		/*Vector specific routines {{{*/
+		void    Echo(void);
+		void    AXPY(Vector *X, IssmDouble a);
+		void    AYPX(Vector *X, IssmDouble a);
+		void    Assemble(void);
+		void    Copy(Vector *to);
+		IssmDouble  Dot(Vector *vector);
+		Vector *Duplicate(void);
+		void    GetValue(IssmDouble *pvalue, int dof);
+		void    GetSize(int *pM);
+		void    GetLocalSize(int *pM);
+		bool    IsEmpty(void);
+		IssmDouble  Norm(NormMode norm_type);
+		void    PointwiseDivide(Vector  *x,Vector*y);
+		void    Scale(IssmDouble scale_factor);
+		void    Set(IssmDouble value);
+		void    SetValues(int ssize, int *list, IssmDouble*values, InsMode mode);
+		void    SetValue(int dof, IssmDouble value, InsMode mode);
+		IssmDouble *ToMPISerial(void);
+		/*}}}*/
+};
+
+
+#endif //#ifndef _VECTOR_H_
Index: issm/branches/trunk-jpl-damage/src/c/classes/matrix/matrixobjects.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/classes/matrix/matrixobjects.h	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/classes/matrix/matrixobjects.h	(revision 12878)
@@ -0,0 +1,16 @@
+/* \file matrixobjects.h
+ * \brief: prototype header for all matrix objects.
+ */
+
+#ifndef ALL_MATRIX_OBJECTS_H_
+#define ALL_MATRIX_OBJECTS_H_
+
+
+/*Numerics:*/
+#include "./ElementMatrix.h"
+#include "./ElementVector.h"
+#include "./Vector.h"
+#include "./Matrix.h"
+
+
+#endif
